/**
 * 
 * Alternative way to specify custom components
 * Array of:
 *  file names (for .js)
 *  directory names (load all js file in directory)
 * This is simpler as component name is provided by the component file
 *
 */ 

module.exports = {
  components: [
    // Components for testing
    './testing',

    // TelcoBot
    './telco/mobile_chargeaccount',
    './telco/mobile_eligible',
    './telco/mobile_loaddata',
    './telco/mobile_usage',
    './telco/mobile_billpay',
    './telco/mobile_statement',

    // RetailBot
    './retail/ListStores',
    './retail/StoreInfo',
    './retail/OrderSummary',
    './retail/CancelOrder',
    './retail/GiftCardBalance',
    './retail/InventoryCheck',
    './retail/ReturnStatus',
    './retail/Greeting',
    './retail/ListOrders',
    './retail/Agent',
    './retail/FAQ',
    './retail/Community',
    './retail/ApptSetup',

    // Utility components
    './util/action_from_variable',
    './util/set_variables_from_file',
    './util/set_variable_from_entity_matches',
    './util/output_variables',
    './util/conditional_is_null',

    // Hackathon - stocks bot
    './stocks/stock_info',
    './stocks/trade_preview',
    './stocks/trade_confirm',
    './stocks/BankUserProfile',
    './stocks/two_factor_auth',
    './stocks/check_auth',

    // Hackathon - Hello Kids
    './parenting/hello_kids',

    // External Agent Reference Implementation
    './agent/switchboard'
  ]
};
