"use strict"

module.exports = {

metadata: () => ({
    "name": "parenting.HelloKids",
    "properties": {
        "goo": { "type": "string", "required": false }
    },
    "supportedActions": [
        "success",
        "fail"
    ]
}),

invoke: (conversation, done) => {
    // Parse a number out of the incoming message
    var dunnos = [ 'dunno', 'Not sure', 'Never heard of that, sorry.'];

    var nos = [ 'maybe', 'ask me later', "I don't think so", "That doesn't sound like a good idea"];

    var uhhuhs = [ 'cool', "That's cool", "Awesome!", "Nice!", "uh huh", "ok", "Good for you", "Neat!"];

    var empathy = [ 'Oh!  Are you ok?', "I'm sorry to hear that!", "That wasn't nice"];

    const text = conversation.text();

    const normalizedText = text.toLowerCase();

    var response = null;

    var isQuestion = text.endsWith("?") ||  normalizedText.startsWith("can ") ||
            normalizedText.startsWith("what ") ||
    normalizedText.startsWith("who " ) ||
    normalizedText.startsWith("how ") ||
    normalizedText.startsWith("why ") ||
    normalizedText.startsWith("may ") ||
    normalizedText.startsWith("please ");

    var isDesire = normalizedText.includes("want ") || normalizedText.includes("have ") ||
                    normalizedText.includes("give ") || normalizedText.includes("need ");

    var isGrievance = normalizedText.includes("hit ") || normalizedText.includes("hurt ") ||
                        normalizedText.includes(" hurts") ||
                        normalizedText.includes("cry ") || normalizedText.includes(" mean") ||
                        normalizedText.includes(" sad");


    const lastText = conversation.variable("user.lastQuestion");
    const lastResponse = conversation.variable("user.lastResponse");

    if (normalizedText === "tell me a story" || normalizedText === "tell us a story")
    {
        conversation.reply("Humpty Dumpty sat on a wall.");
        conversation.reply("Humpty Dumpty had a great fall.");
        conversation.reply("All the King's horses and all the King's men...");
        conversation.reply("couldn't put Humpty Dumpty together again.");

        // Set action based on age check
        conversation.transition('good');

        done();
    } else if ((normalizedText.startsWith("i ") || normalizedText.startsWith("you ")) && !normalizedText.endsWith(" too"))
    {
        response = text + " too";
    } else if (normalizedText === "what?" && lastResponse != null)
    {
        response = lastResponse;
    } else
    if (text === lastText)
    {
        if (lastResponse && lastResponse.startsWith("I said"))
        {
            response = "Stop whining!";
        } else
        {
            response = 'I said "' + lastResponse + '"';
        }
    } else
    {
        // wants something: say no.
        // question:  say no
        // makes a neutral statement: uh-huh
        //
        if (!isQuestion && isGrievance)
        {
            response = empathy[Math.floor(Math.random() * empathy.length)];

        } else if (isQuestion && isDesire)
        {
            response = nos[Math.floor(Math.random() * nos.length)];

        } else if (isDesire)
        {
            response = uhhuhs[Math.floor(Math.random() * uhhuhs.length)];
        } else if (isQuestion)
        {
            var request = require('request');

            var proxyRequest = request.defaults({'proxy': process.env.HTTP_PROXY});

            var query = text.replace(" ", "+").replace("?", "");

            var url = 'http://api.duckduckgo.com/?format=json&q=' + query;

            proxyRequest.get({url:url}, function(err, httpResponse, body) {
              if (err) {
                conversation.logger().info('post failed:', err);
              }
              conversation.logger().info('Get successful!  Server responded with:', body);

              conversation.logger().info("body.Abstract is " + body.Abstract);
              var bodyJson = JSON.parse(body);
              if (bodyJson.Abstract)
              {
                response = bodyJson.Abstract;
                if (response.indexOf(".") > -1)
                {
                    response = response.substring(0, response.indexOf(".") + 1);
                }
              } else
              {
                response = dunnos[Math.floor(Math.random() * dunnos.length)];
              }

                conversation.variable("user.lastQuestion", text);
                conversation.variable("user.lastResponse", response);

                conversation.reply(response);

                // Set action based on age check
                conversation.transition('good');

                done();

            });

        } else
        {
            response = uhhuhs[Math.floor(Math.random() * uhhuhs.length)];
        }
    }

    if (response)
    {

        conversation.variable("user.lastQuestion", text);
        conversation.variable("user.lastResponse", response);

        conversation.reply(response);

        // Set action based on age check
        conversation.transition('good');

        done();
    }
}
};
