"use strict";

const StoreService = require('./StoreService');

module.exports = {

    metadata: () => ({
        "name": "retail.CancelOrder"
    }),

    invoke: (conversation, done) => {
        const orderId = conversation.text();
        var orders = StoreService.orders();
        const order = orders[orderId];
        if (order === undefined){
            conversation.reply("Invalid order ID! Order does not exist!");
            conversation.transition();
            done();
        }
        else{
            var status = order["status"];
            switch (status){
                case "shipped":
                    conversation.reply("Order (#"+orderId+") has shipped, cannot cancel order!");
                    break;
                case "pending":
                    //remove the comment slash to make the ccc remember order state
                    //delete orders[orderId];
                    conversation.reply("Order (#"+orderId+") has been canceled!");
                    break;
                case "delivered":
                    conversation.reply("Order (#"+orderId+") has been delivered, cannot cancel order!");
            }
            conversation.transition();
            done();

        }

    }
};
