"use strict";

var FAQService = require('./FAQService');

module.exports = {

    metadata: () => ({
        "name": "retail.FAQ",
        "properties": {
            "nlpVariable": { "type": "string", "required": true }
        },
        "supportedActions": [
        ]
    }),

    invoke: (conversation, done) => {
        var nlpVariable = conversation.properties().nlpVariable;
        var nlpResult = conversation.variable(nlpVariable);

        if (nlpResult.intentMatches && Array.isArray(nlpResult.intentMatches.detail.final_norm)) {
            if (nlpResult.intentMatches.detail.final_norm.length > 0) {
                let faq = nlpResult.intentMatches.detail.final_norm[0];
                conversation.logger().info('FAQ: answering question=' + faq.sentence);
                conversation.reply(FAQService.answerFor(faq.sentence));
            }
        }
        else {
            conversation.reply('Sorry, we don\'t have an answer for that question. Send us an email at support@seawheeze.com or give our GEC a call at 1.866.412.5662.');
        }

        conversation.transition();
        done();
    }
};
