"use strict";

var baseUtils = require("../util/baseUtils.js");
var storeService = require("./StoreService.js");

module.exports = {

    metadata: () => ({
        "name": "retail.GiftCardBalance",
        "properties": {
            "giftCardId": { "type": "string", "required": true }
        },
        "supportedActions": [
            "success",
            "fail"
        ]
    }),

    invoke: (conversation, done) => {
        // Parse a number out of the incoming message
        var balance = 0;
        if(baseUtils.isEmpty(conversation.properties().giftCardId)){
            conversation.reply("This number is not valid");
        }else{
            var cardId = conversation.properties().giftCardId;
            var response = "This card does not exist";

            var giftcards = storeService.giftcards();
            for (var item in giftcards) {
                balance += parseFloat(giftcards[item].value);
                if(giftcards[item].id == cardId){
                    response = cardId + " balance is " + balance;
                }
            }

            conversation.reply(response);
            conversation.reply("Your overall gift card balance : " + JSON.stringify(balance));
        }
        conversation.transition();
        done();
    }
};
