"use strict";

const StoreService = require('./StoreService');

module.exports = {

    metadata: () => ({
        "name": "retail.ListOrders",
        "properties": {
            "customerID": { "type": "string", "required": true },
            "prompt": {"type": "string", "required": true}
        },
        "supportedActions": [
        ]
    }),

    invoke: (conversation, done) => {
    	conversation.logger().info('retail.ListOrders invoked with custumerID=' + conversation.properties().customerID);
      var orders = StoreService.orders();
    	const customerID = conversation.properties().customerID;

    	var retArray = [];
    	for (var order in orders) {
            let customerId = orders[order]["customerId"];
            conversation.logger().info(customerId);
            if (customerId == customerID){
            	retArray.push(order);
            }
        }
    	conversation.reply({text: conversation.properties().prompt, choices: retArray, type: "choice"});
    	conversation.transition();

      done();
    }
};
