"use strict";

const StoreService = require('./StoreService');

module.exports = {

    metadata: () => ({
        "name": "retail.ListStores",
        "properties": {
            "location": { "type": "string", "required": true }
        },
        "supportedActions": [
        ]
    }),

    invoke: (conversation, done) => {
        conversation.logger().info('lululemon.ListStores invoked with location=' + conversation.properties().location);
        var stores = StoreService.stores({location: conversation.properties().location});
        for (var storeId in stores) {
            let store = stores[storeId];
            //conversation.reply(JSON.stringify(store));
            var mapsUrl = 'https://www.google.com/maps/search/?api=1'+'&query='+store.lat+','+store.long;
            var MessageModel = conversation.MessageModel();
            var mapAction = MessageModel.urlActionObject('Open Map', null, mapsUrl);
            var locationMessage = MessageModel.locationConversationMessage(store.lat, store.long, store.name+ ' - '+store.address, mapsUrl, [mapAction]);
            conversation.reply(locationMessage);
            /*
            conversation.reply({
                text:'' + store.name + '. ' + store.address + '. Open ' + store.hours,
                map: {
                    address: store.address,
                    lat: store.lat,
                    long: store.long
                }
            });
            */
        }

        conversation.transition();

        done();
    }
};
