"use strict";

const StoreService = require('./StoreService');

module.exports = {

    metadata: () => ({
        "name": "retail.OrderSummary"
    }),

    invoke: (conversation, done) => {
        const orderId = conversation.text();
        var orders = StoreService.orders();
        const order = orders[orderId];
        if (order === undefined){
            conversation.reply("Invalid order ID! Order does not exist!");
            conversation.transition();
            done();
        }
        else{
            var status = order["status"]
            switch (status){
                case "shipped":
                    conversation.reply("Order(#"+orderId+") has shipped, thank you!");
                    break;
                case "pending":
                    conversation.reply("Order(#"+orderId+") is processing, thank you!");
                    break;
                case "delivered":
                    conversation.reply("Order(#"+orderId+") has been delivered, thank you!");
            }
            var items = order["items"];
            items.forEach(function(item){
                conversation.reply("-  "+item["name"]);
            })
            conversation.transition();
            done();

        }
    }
};
