"use strict";

module.exports = {

    metadata: () => ({
        "name": "retail.ReturnStatus",
        "properties": {
            "orderNumber": { "type": "string", "required": true },
            "refundOption": { "type": "string", "required": false }
        },
        "supportedActions": [
            "success",
            "fail"
        ]
    }),

    invoke: (conversation, done) => {

    const text = conversation.text();

    conversation.logger().info('ReturnStatus intent invoked' + text);

    var orderNumber = conversation.variable('orderNumber');
    conversation.logger().info('orderNumber in cache:' + orderNumber);

    var matches = null;
    if ( orderNumber == null ) {
        // Try getting order number from input
        matches = text.match(/LL[a-z\d]+/ig);
        if (matches == null) {
            matches = text.match(/#[a-z\d]+/ig);
        }
    }

    if ( matches != null || orderNumber != null ) {

        // Order number found
        conversation.variable('orderNumber', matches+'');

        var matchRefundOptions = text.match(/credit card/i);

        if (matchRefundOptions == null) {
            matchRefundOptions = text.match(/store credit/i);
        }

        if (matchRefundOptions == null) {
            matchRefundOptions = text.match(/visa cash card/i);
        }

        if (matchRefundOptions == null)
            matchRefundOptions = conversation.variable('refundOption');
        else {

            conversation.logger().info('Refund option has been set in this input to: '+ matchRefundOptions );
        }

        if ( matchRefundOptions == null) {
            conversation.reply({text: "We are processing your return, you may change refund option.", choices: ["My credit card (default)", "Visa cash card", "Store credit"], type: "choice"});
        }
        else if ( matchRefundOptions[0].toLowerCase() == "store credit" ) {
            conversation.reply("We have just accepted your return. You will receive the Store Credits within a business day.");
            conversation.transition();
        }
        else {
            conversation.reply("We just accepted your return, You will get your refund within 2 business days.");
            conversation.transition();
        }
    }
    else {

        // Order number not entered
        conversation.reply("What is your order number?");
    }

    done();

    }

};
