"use strict";

const moment = require('moment');
const DATA_ROOT = './data/';

function roundToTwo(num) {
    return +(Math.round(num + "e+2")  + "e-2");
}

const STORES_BASE = {
};
const STORE_BASE = {
};
const ORDERS_BASE = {
};
const ORDER_BASE = {
};
const GIFTCARDS_BASE = {
};
const GIFTCARD_BASE = {
};
const PRODUCTS_BASE = {
};
const PRODUCT_BASE = {
};
const COMMUNITY_BASE = {
};
const TIMES_BASE = {
};

const STORES = Object.assign(require(DATA_ROOT + 'stores.json'), STORES_BASE);
const ORDERS = Object.assign(require(DATA_ROOT + 'orders.json'), ORDERS_BASE);
const GIFTCARDS = Object.assign(require(DATA_ROOT + 'giftcards.json'), GIFTCARDS_BASE);
const PRODUCTS = Object.assign(require(DATA_ROOT + 'products.json'), PRODUCTS_BASE);
const COMMUNITIES = Object.assign(require(DATA_ROOT + 'community.json'), COMMUNITY_BASE);
const TIMES = Object.assign(require(DATA_ROOT + 'times.json'), TIMES_BASE);

module.exports = {
    stores: (filter) => {
        var results = STORES;
        if (filter && filter.location) {
            results = {};
            for (var storeId in STORES) {
                var store = STORES[storeId];
                if (store.address.toUpperCase().indexOf(filter.location.toUpperCase()) !== -1) {
                    results[storeId] = store;
                }
            }
        }
        return results;
    },

    orders: (filter) => {
        return ORDERS;
    },

    giftcards: (filter) => {
        return GIFTCARDS;
    },

    products: (filter) => {
        return ORDERS;
    },

    availableTimes: (filter) => {
        return TIMES;
    },

    communities: (filter) => {
        var results = COMMUNITIES;
        if (filter && filter.type) {
            results = {};
            for (var eventId in COMMUNITIES) {
                var event = COMMUNITIES[eventId];
                if (event.type.toUpperCase().indexOf(filter.type.toUpperCase()) !== -1) {
                    results[eventId] = event;
                }
            }
        }
        return results;
    }
};
