"use strict";

var JetsonsBank = require('./JetsonsBank');

module.exports = {

    metadata: () => ({
        "name": "stocks.BankUserProfile",
        "properties": {
        	"mobilePhone": { "type": "string", "required": true },
        	"username": { "type": "string", "required": true }
        },
        "supportedActions": [
            "success",
            "fail"
        ]
    }),

    invoke: (conversation, done) => {

        // Parse a number out of the incoming message
        const oAuth2Code = conversation.variable("oauth2Code");

        conversation.logger().info('oAuth2Code is ' + oAuth2Code);

        if (!oAuth2Code){
            done();
        }

        var bank = new JetsonsBank();
        var profile = bank.getProfile(oAuth2Code);
        if(profile) {

	        var mobilePhoneTarget = conversation.properties().mobilePhone
	        var usernameTarget = conversation.properties().username

	        conversation.variable(usernameTarget, profile['user_name']);
	        var mobilePhoneEntityValue = {};
	        mobilePhoneEntityValue.phoneNumber = profile['mobile_phone'];
	        mobilePhoneEntityValue.countryCode = "1";
	        mobilePhoneEntityValue.completeNumber = profile['mobile_phone'];

	        conversation.variable(mobilePhoneTarget, mobilePhoneEntityValue);
	        conversation.transition('success');
	    }
	    else {
	    	conversation.logger().info("BankUserProfile: didn't find the oAuth - not setting any new values.");
	    	conversation.transition('success');
	    }
        done();
    }
};
