"use strict";

module.exports = {

    metadata: () => ({
        "name": "stocks.GetAuthURL",
        "properties": {
            "loginPageURL": {
                "type": "string",
                "required": true
            },
            "redirectURL": {
                "type": "string",
                "required": true
            }
        },
        "supportedActions": [
            "success",
            "fail"
        ]
    }),

    invoke: (conversation, done) => {
        var loginPageURL = conversation.properties().loginPageURL;
        var redirectURL = conversation.properties().redirectURL;
        var authURL;

        if (loginPageURL && redirectURL) {
            if (!loginPageURL.endsWith('&')) {
                loginPageURL = loginPageURL + '?';
            }
            authURL = loginPageURL + 'redirect_uri=' + encodeURIComponent(redirectURL);
            conversation.logger().info('authURL: ' + authURL);
            conversation.variable("authURL", authURL);
        }
        conversation.transition();
        done();
    }
};
