'use strict';

module.exports = {

    metadata: () => ({
        "name": "stocks.GetStockInfo",
        "properties": {
            "stockSymbol": {
                "type": "string",
                "required": true
            }
        },
        "supportedActions": [
            "success",
            "fail"
        ]
    }),

    invoke: (conversation, done) => {
        var stockSymbol = conversation.properties().stockSymbol;
        var stockGraphUrl = "https://www.google.com/finance/getchart?q="+stockSymbol+"&p=1Y&i=86400";
        var payload = {
            "url": stockGraphUrl
        };
        var attachment = {
            "type": "image",
            "payload": payload
        };
        var message = {
            "attachment": attachment
        };

        var channelType = conversation.channelType();
        if (channelType === 'facebook') {
            conversation.reply(message);
            conversation.transition();
            done();
        } else {
          var request = require('request');
          var proxyRequest = request.defaults({'proxy': process.env.HTTP_PROXY});
            var LastTradePrice;
            //var url = 'http://query.yahooapis.com/v1/public/yql?q=select * from yahoo.finance.quotes where symbol in ("' + stockSymbol + '")&env=store://datatables.org/alltableswithkeys&format=json';
            var url = 'http://download.finance.yahoo.com/d/quotes.csv?s=' + stockSymbol + '&f=snl1pt8';
            url = encodeURI(url);
            conversation.logger().info(url);

            proxyRequest(url, function(error, response, body) {
                if (!error && response.statusCode == 200) {
                  var resultStr = body;
                  conversation.logger().info('stock quote result',resultStr);
                  var resultArray = resultStr.split(',');

                  LastTradePrice = resultArray[2];
                  conversation.logger().info('last trade price of the stock is: ' + LastTradePrice);
                    conversation.reply({
                        text: 'current trade \xa0 price is ' + LastTradePrice
                    });
                } else {
                    conversation.reply({
                        text: 'encountered problems getting stock quote'
                    });
                    conversation.logger().info(error);
                    conversation.logger().info(body);
                }
                conversation.transition();
                done();
            });
        }
    }
};
