"use strict";

module.exports = {

    metadata: () => ({
        "name": "stocks.TradePreview",
        "properties": {
            "buySell": {
                "type": "string",
                "required": true
            },
            "operation": {
                "type": "string",
                "required": true
            },
            "stockSymbol": {
                "type": "string",
                "required": true
            },
            "amount": {
                "type": "string",
                "required": true
            },
            "opAmount": {
                "type": "string",
                "required": true
            }
        },
        "supportedActions": [
            "success",
            "fail"
        ]
    }),

    invoke: (conversation, done) => {
//        var buySell = conversation.properties().buySell;
        var operation = conversation.properties().operation;
        var stockSymbol = conversation.properties().stockSymbol;
        var amount = conversation.properties().amount;
        var opAmount = conversation.properties().opAmount;

        var request = require('request');
        var proxyRequest = request.defaults({'proxy': process.env.HTTP_PROXY});
        var stock;
        var LastTradePrice;
        var url = 'http://query.yahooapis.com/v1/public/yql?q=select%20*%20from%20yahoo.finance.quotes%20where%20symbol%20in%20(%22' +
            stockSymbol +
            '%22)%0A%09%09&env=http%3A%2F%2Fdatatables.org%2Falltables.env&format=json';

        proxyRequest(url, function(error, response, body) {
            if (!error && response.statusCode == 200) {
                var jBody = JSON.parse(body);
                stock = jBody.query.results.quote;
                LastTradePrice = stock.LastTradePriceOnly;
                conversation.logger().info('current trade price of the stock is: ' + LastTradePrice);
            } else {
                conversation.logger().info('error with:', url);
                LastTradePrice = 100;
            }

            var totalAmount;
            if (operation === 'limit') {
                totalAmount = amount * opAmount;
            } else {
                totalAmount = amount * LastTradePrice;
            }

            var channelType = conversation.channelType();
            if (channelType === 'facebook') {
                var stockGraphUrl = "http://chart.finance.yahoo.com/z?s=" + stockSymbol + "&t=1m&q=l&l=on&z=s&p=m50,m200";

                var elementStockGraph = {
                    "title": "stockSymbol: " + stockSymbol,
                    "image_url": stockGraphUrl
                };

                var elementStockSymbol = {
                    "title": "current trade price of the stock is " + LastTradePrice +
                        ", you total transaction amount is " + totalAmount,
                    "subtitle": "please confirm ..."
                };

                var elementConfirm = {
                    "title": "Confirm",
                    "buttons": [{
                        "type": "postback",
                        "title": "Confirm",
                        "payload": "Confirm"
                    }]
                };

                var elementCancel = {
                    "title": "Cancel",
                    "buttons": [{
                        "type": "postback",
                        "title": "Cancel",
                        "payload": "Cancel"
                    }]
                };

                var payload = {
                    "template_type": "list",
                    "top_element_style": "large",
                    "elements": [elementStockGraph, elementStockSymbol, elementConfirm, elementCancel]
                };

                var attachment = {
                    "type": "template",
                    "payload": payload
                };

                var message = {
                    "attachment": attachment
                };

                conversation.reply(message);

                conversation.transition();
                done();
            } else {
                conversation.reply({
                    text: 'current trade price is ' + LastTradePrice +
                        ', you total transaction amount is ' + totalAmount +
                        ', please Confirm or Cancel the operation'
                });
                conversation.transition();
                done();
            }
        });

    }
};
