"use strict";

module.exports = {

    metadata: () => ({
        "name": "stocks.TwoFactorAuth",
        "channels": {
            "facebook": "1.0"
        },
        "properties": {
            "mobilePhone": {
                "type": "string",
                "required": false
            }
        },
        "supportedActions": [
            "check",
            "skip"
        ]
    }),

    invoke: (conversation, done) => {

        // Twilio Credentials (Enter your own here)
        var accountSid = '<enter your own>';
        var authToken = '<enter your own>';
        var fromPhone = '<enter your own>';

        //var authHeader = 'Basic QUM1OTk3MDA1MWFiMmE0OTE5NTI5ZGNlNzM5MTA5YzJlODoyMGJiYmNmMTk1Y2UyOTE0ZDYyYTRhNzBmNzBiNThlZA==';
        var authHeader = new Buffer(accountSid+':'+authToken).toString('base64');
        authHeader = 'Basic '+authHeader;

        //require the Twilio module and create a REST client
        var client = require('twilio')(accountSid, authToken);

        var code = Math.floor(Math.random() * 9000) + 1000;

        var clientPhone = conversation.properties().mobilePhone;

        // two factor auth not setup for this particular user
        if (!clientPhone || clientPhone === '+12223334444') {
            conversation.transition("skip");
            done();
            return;
        }

        conversation.variable("twilio_code", '' + code);

        var request = require('request');
        var proxyRequest = request.defaults({
            'proxy': process.env.HTTP_PROXY
        });
        var url = 'https://api.twilio.com/2010-04-01/Accounts/'+accountSid+'/Messages.json';
        var data = {
            To: clientPhone,
            From: fromPhone,
            Body: 'Your StockBot verification code is: ' + code + "."
        };

        proxyRequest.post({
            url: url,
            headers: {
                'Authorization': authHeader
            },
            formData: data
        }, function(err, httpResponse, body) {
            var bodyParsed = JSON.parse(body);
            if (bodyParsed.status && bodyParsed.status >= 400) {
                conversation.logger().info('post failed:', err);
                conversation.reply('Please check the twilio auth setup. Error reported.');
                conversation.reply(bodyParsed.message);
                conversation.transition("skip");
            } else {
                conversation.logger().info('Post successful!  Server responded with:', body);
                conversation.reply('Please check your phone for a verification code and reply with it.');
                conversation.transition("check");
            }
            done();
        });

        conversation.logger().info("Have called Twilio via REST now.");

    }
};
