"use strict";

var Mobile = require('./MobileAccountService');

module.exports = {

    metadata: () => ({
        "name": "MobileBillPay",
        "properties": {
            "paymentAccount": { "type": "string", "required": true }
        },
        "supportedActions": [
        ]
    }),

    invoke: (conversation, done) => {
        var paymentAccount = conversation.properties().paymentAccount;
        conversation.logger().info('MobileBillPay: paying statement from ' + paymentAccount);

        conversation.reply({ text: 'Thank you, your payment of ' + Mobile.account().payment_due_amount + ' (from ' + paymentAccount + ') has been applied.'});

        Mobile.account().payment_due_amount = '$0.00';

        conversation.transition();

        done();
    }
};
