"use strict";

var Mobile = require('./MobileAccountService');

module.exports = {

    metadata: () => ({
        "name": "MobileEligible",
        "properties": {
          "numberToUpgrade": { "type": "string", "required": true }
        },
        "supportedActions": [
        ]
    }),

    invoke: (conversation, done) => {
        var numberToUpgrade = conversation.properties().numberToUpgrade;
        conversation.logger().info('MobileEligible: querying for number ' + numberToUpgrade);

        conversation.transition( Mobile.account().phone_numbers[numberToUpgrade] &&
                    Mobile.account().phone_numbers[numberToUpgrade].is_eligible_for_upgrade ? 'yes' : 'no' );

        done();
    }
};
