"use strict";

module.exports = {

    metadata: () => ({
        "name": "LocationBasedOptions",
        "properties": {
            "location": { "type": "string", "required": true },
            "variable": { "type": "string", "required": true }
        },
        "supportedActions": [
        ]
    }),

    invoke: (conversation, done) => {
        var AVAIL_OPTIONS = [
      		  'Toronto',
  		      'Sydney',
  		      'Paris',
  		      'Rome',
  		      'Tokyo'
  	      ];

        // Determine valid options
        var returnedOptions = null;
        if (conversation.properties().location === 'random') {
            returnedOptions = AVAIL_OPTIONS.slice(0, getRandomInt(1, AVAIL_OPTIONS.length));
        }
        else {
            returnedOptions = AVAIL_OPTIONS;
        }

        var text = conversation.text();
        var variableName = conversation.properties().variable;
        var variableValue = conversation.variable(variableName);

        if (variableValue == null || variableValue == undefined) {
            if (returnedOptions.includes(text)) {
                conversation.variable(variableName, text);
            }
            else {
                // TODO: Only supporting test UI for now, reply should be based on channel type!
                conversation.reply({
                    text: 'Your options are based on your location.'
                });
                conversation.reply({
                    text: 'The options you have are:',
                    choices: returnedOptions
                });
            }
        }

        done();
    }
};

function getRandomInt(min, max) {
  min = Math.ceil(min);
  max = Math.floor(max);
  return Math.floor(Math.random() * (max - min)) + min;
}
