"use strict";

var request = require('request');

module.exports = {

    metadata: () => ({
        "name": "WeatherQuery",
        "properties": {
            "location": { "type": "string", "required": true }
        },
        "supportedActions": [
            "success",
            "fail"
        ]
    }),

    invoke: (conversation, done) => {
        const baseUrl = 'http://api.openweathermap.org/data/2.5/weather?q=';
        const key = '&appid=416d0a7f43f6e2d8053904ac4cbc889e';

//        var url = baseUrl + conversation.variable(conversation.properties().location) + key;
        var url = baseUrl + conversation.properties().location + key;
        conversation.logger().info('Calling out to=' + url);
        request(url, (error, response, body) => {
            if (!error && response.statusCode == 200) {
                body = JSON.parse(body);
                if (body.hasOwnProperty('weather')) {
                    conversation.reply({ text: body.weather[0].description });
                }
                else {
                    conversation.reply(body);
                }
            }
            else {
                conversation.logger().info(error);
            }
            conversation.transition();
            done();
        });
    }
};
